; this is the PWactivate keyword for the Prowess Sbasic interface
; v. 1.01     1996 May 01 14:26:57
;  W. Lenerz 1996

*************************************************************************
*
* This is the PWactivate keyword
*
* syntax: result = PWactivate(object,old_result,object_hit,add_info,event%)
*
* where:	object is the object to activate
*	old_result is the result returned, from an earlier PWactivate call
*	of the same object. If this is the first call, use 0
***************************************************************************

	section	text
	
	xdef	pwactivate
	xdef	err_out
	xdef	e_o
	
	include	asm_includes_asm
	xref	_pwactivate
	xref	gmem		; gets mem in my format (prowess_asm_pwcreate)
	xref	gu_rchp		; rel mem (gu_rechp_asm)
	xref	rt_fp		; return fp to basic (lib_returnparams)
	xref	get_param 	; gets para from sbasic interpreter (prowess_asm_getparams)
	xref	get_long		;  "   "	    "    "        "          "

pwactivate
	ADDQ.L	#8,A3
	LEA	8(A3),A5		; point to second parameter
	BSR	get_param 	; get it now
	BNE.S	out		; oops!
	MOVE.L	(A6,A1.L),D7	; this is the pointer to our memory
	BNE.S	do_return 	; if this exists, we come back here from a hit routine
	MOVE.L	#$1000,D0
	BSR	gmem		; get mem and put special info into it
	BSR	get_long		; get object now
	BNE.S	e_o
no_mem	MOVE.L	A4,A7
	BSR	_pwactivate
	TST.L	D0
	BNE.S	err_out
; we get here after a quit from the program
return	reset_stk
	BSR	gu_rchp		; release area (this keeps old error)
	MOVEQ	#0,D2
	BRA	rt_fp		; now return 0

err_out
	reset_stk 		; reset my stack
e_o	BRA	gu_rchp		; release me & return with error
out	RTS			; simple return (with possiblr error)

; this is the pwactivate call that is made after a return was made from the
; "eventhandler" in basic, so we must go back to the Prowess event handler
do_return MOVE.L	D7,A0		; point to bottom of my area
	MOVE.L	(A0),A4		; point to top
	SUB.L	#12,A4		; jump over watermark
	MOVE.L	A0,-(A4)		; start of this space is kept here
	MOVE.L	A6,-(A4)
	MOVE.L	A3,-(A4)		; keep pointer to data
				; leave A7 where it was
	MOVE.L	4(A0),A7		; stack pointer within prowess
	MOVEM.L	(A7)+,evtregs	; return the regs that had been stored there
	MOVE.L	(A7)+,D1		; this had been stored first
	MOVEQ	#0,D0		; there was no error here
	RTS			; return to prowess
	end
